// $Id: accountlist.h,v 1.4 2004/01/25 21:15:12 martin Exp $

// accountlist.h, (C) 2004 Martin Henne

#ifndef _accountlist_h
#define _accountlist_h

#include <qsortedlist.h>
#include <qstring.h>
#include "activityaccount.h"
#include "activity.h"
#include "timespan.h"

class AccountList {
private:
	QSortedList<ActivityAccount> _accounts;
	mutable int _index;
	//ActivityAccount getByName(const QString& name);

public:
	explicit AccountList(QSortedList<Activity>& allActivities);
	void create(QSortedList<Activity>& allActivities);
	ActivityAccount* getNext();
	bool hasNext() const;
	void rewind() const;
	void addActivity(const Activity& activity);
	void clearAccount(const QString& accountName);
	void addAccount(const ActivityAccount& account);
	void changeAccount(const ActivityAccount& account);
	void changeAccount(const QString& name, const TimeSpan& span);
	void changeAccount(int listBoxIndex, const TimeSpan& span);
	void clear();
	bool empty() const;
	bool exists(const QString& name);
	bool exists(const ActivityAccount& account);	int size() const;
	void replace(const ActivityAccount& account);
	void setListBoxIndex(const QString& accountName, int index);
	ActivityAccount* getByListBoxIndex(int index);
	ActivityAccount* getByName(const QString& accountName);
	TimeSpan getOverallSum();
	TimeSpan getOverallSum(const Activity& currentActivity);
	TimeSpan getAccountSum(const QString& name);
};

#endif





