// $Id: activityaccount.h,v 1.6 2004/02/07 17:22:05 martin Exp $

// activityaccount.h, (C) 2004 Martin Henne

#ifndef _activityaccount_h
#define _activityaccount_h

#include <qstring.h>
#include "timespan.h"

class Activity;

class ActivityAccount {
private:
	QString _name;
	TimeSpan _balance;
	int _listBoxIndex;
	bool _report;

public:
	ActivityAccount();
	explicit ActivityAccount(const QString& arg);
	explicit ActivityAccount(const Activity& arg);
	ActivityAccount(const QString& name, const TimeSpan& span);
	ActivityAccount(const ActivityAccount& other);

	void addTimeSpan(const TimeSpan& span);
	void setTimeSpan(const TimeSpan& span);
	TimeSpan getTimeSpan() const;
	QString getName() const;
	QString toString() const;

	bool isSmallerThan(const ActivityAccount&) const;
	bool equals(const ActivityAccount&) const;
	bool operator<(const ActivityAccount&) const;
	bool operator==(const ActivityAccount&) const;
	bool report() const;
	bool getReport() const;
	void setReport(bool arg);
	
	void setListBoxIndex(int idx);
	int getListBoxIndex() const;
};

#endif



