// $Id: activitydetailsdialog.cpp,v 1.4 2004/02/10 02:32:11 martin Exp $

// activitydetailsdialog.cpp, (C) 2004 Martin Henne

#include "activitydetailsdialog.h"
#include "activitydetailsdialogbase.h"
#include "activity.h"
#include "usertextinput.h"
#include "datetimeinput.h"
#include "io.h"
#include <qlabel.h>
#include <qpushbutton.h>


ActivityDetailsDialog::ActivityDetailsDialog(Activity& activity) : ActivityDetailsDialogBase(0,0,true,0), _activity(activity) {
    std::fprintf(stderr,"ActivityDetailsDialog::ActivityDetailsDialog()\n");
    nameText->setText(_activity.getName() );
    startText->setText(_activity.getStartString() );
    endText->setText(_activity.getEndString() );
    durationText->setText(_activity.getTimeSpanString() );
}


void ActivityDetailsDialog::accept() {
    std::fprintf(stderr,"ActivityDetailsDialog::accept()\n");
    this->hide();
}


void ActivityDetailsDialog::reject() {
    std::fprintf(stderr,"ActivityDetailsDialog::reject()\n");
    _activity.setName("");
    this->hide();
}


void ActivityDetailsDialog::changeNameSlot() {
    std::fprintf(stderr,"ActivityDetailsDialog::changeNameSlot()\n");    
    QString newName = UserTextInput()("Change Name","Enter new activity name!");
    if(newName != "") {
	this->_activity.setName(newName);
	nameText->setText(_activity.getName() );	
	std::fprintf(stderr,"ActivityDetailsDialog::changeNameSlot(): new name is '%s'\n",newName.latin1() );
    }
    else {
	std::fprintf(stderr,"ActivityDetailsDialog::changeNameSlot(): keeping old name\n");
    }
}


void ActivityDetailsDialog::changeStartSlot() {
    std::fprintf(stderr,"ActivityDetailsDialog::changeStartSlot()\n");
    QDateTime dt = this->_activity.getStart();
    QDateTime newDt = DateTimeInput()(dt);
    this->_activity.setStart(newDt);
    this->startText->setText(this->_activity.getStartString() );
    this->durationText->setText(this->_activity.getTimeSpanString() );
    std::fprintf(stderr,"ActivityDetailsDialog::changeStartSlot(): new start time '%s'\n",newDt.toString().latin1() );
}


void ActivityDetailsDialog::changeEndSlot() {
    std::fprintf(stderr,"ActivityDetailsDialog::changeEndSlot()\n");
    QDateTime dt = this->_activity.getEnd();
    QDateTime newDt = DateTimeInput()(dt);
    this->_activity.setEnd(newDt);
    this->endText->setText(this->_activity.getEndString() );
    this->durationText->setText(this->_activity.getTimeSpanString() );
    std::fprintf(stderr,"ActivityDetailsDialog::changeEndSlot(): new end time '%s'\n",newDt.toString().latin1() );
}


void ActivityDetailsDialog::removeSlot() {
    std::fprintf(stderr,"ActivityDetailsDialog::removeSlot()\n");
    if(!askYesNo()("Remove Activity?")) return;
    _activity.setName("--REMOVEME--");
    hide();
}


void ActivityDetailsDialog::setRemoveButtonEnabled(bool active) {
    removeButton->setEnabled(active);
}






