// $Id: activitylist.h,v 1.5 2004/02/08 01:49:18 martin Exp $

// activitylist.h, (C) 2004 Martin Henne

#ifndef _activitiylist_h
#define _activitylist_h

#include "activity.h"
#include "activityaccount.h"
#include "timespan.h"
#include <qsortedlist.h>
class QDate;
class QString;

class ActivityList {
    public:
    static QSortedList<Activity> getPartByLastFirst(
	QSortedList<Activity>,
	const QDate& firstDay,
	const QDate& lastDay);
    
    static QSortedList<Activity> getPartByDay(
	QSortedList<Activity>,
	const QDate& day);
    
    static QSortedList<Activity> getFirstPart(
	QSortedList<Activity>,
	const QDate& lastDay);
    
    static QSortedList<Activity> getLastPart(
	QSortedList<Activity>,
	const QDate& firstDay);
    
    static QSortedList<Activity> getPartByName(
	QSortedList<Activity>,
	const QString& activityName);
    
    static QSortedList<Activity> exclude(
	QSortedList<Activity>,
	const QString& nameToExclude);
    
    static QSortedList<QString> getProjectNames(
	QSortedList<Activity>);
    
    static TimeSpan getProjectSummary(
	QSortedList<Activity>, 
	const QString& projectName);
    
    static TimeSpan getProjectSummary(
	QSortedList<Activity>, 
	const QString& projectName,
	const QDate& day);    
    
    static QSortedList<ActivityAccount> getProjectSummaryList(
	QSortedList<Activity>);
    
    static QDate getFirstDay(QSortedList<Activity>);
    static QDate getLastDay(QSortedList<Activity>);
};

#endif




