//
// C++ Interface: composefilename
//
// Description: 
//
//
// Author: Martin Henne <martin.henne@web.de>, (C) 2004
//
// Copyright: See COPYING file that comes with this distribution
//
//

#ifndef _composefilename_h
#define _composefilename_h

#include "composefilenamebase.h"
class QString;

class ComposeFileName : public ComposeFileNameBase {
    private:
    explicit ComposeFileName(const QString& defaultName);    
    const QString& _default;
    bool _rejected;    
    QString _newName;

    public:
    virtual void dashSlot();
    virtual void dateSlot();
    virtual void defaultSlot();
    virtual void dotSlot();
    virtual void homeSlot();
    virtual void htmlSlot();
    virtual void slashSlot();
    virtual void timeSlot();
    virtual void txtSlot();
    virtual void xmlSlot();
    virtual void cfSlot();
    virtual void cardSlot();
    
    void append(const QString&);
    void prepend(const QString&);
    void insert(const QString&);
    void removeKnownSuffix();
    QString getAndRemoveSuffix();
    
    static QString show(const QString& defaultName);
    
    virtual void reject();
    virtual void accept();
};

#endif





