// $Id: datedialog.cpp,v 1.6 2004/02/08 01:49:18 martin Exp $

// datedialog.cpp, (C) 2003 Martin Henne

#include "datedialog.h"
#include <qwidget.h>
#include <qstring.h>
#include <qdatetime.h>
#include <qlabel.h>
#include <qpushbutton.h>
#include <qspinbox.h>
#include <cstdlib>
#include "io.h"

DateDialog::DateDialog(
    QWidget* parent,
    const char* name,
    QDate& date
    ) : DateDialogBase(parent,name,true,0), _value(date), _rejected(false) {
    textLabel->setText( _value.toString() );
}



//::accept()//::accept()//::accept()//::accept()//::accept()//::accept()//::accept()//::accept()//::accept()//::accept()//::accept()//::accept()//::accept()
void DateDialog::accept() {
    //println()(__FILE__);
    hide();
}




//::daySlot()//::daySlot()//::daySlot()//::daySlot()//::daySlot()//::daySlot()//::daySlot()//::daySlot()//::daySlot()//::daySlot()//::daySlot()//::daySlot()
void DateDialog::daySlot() {
    const QObject* signalSender = sender();
    
    // This should never happen
    if( !(signalSender->isA("QPushButton")) ) {
	println()
	    ("FATAL: DateDialog::hourSlot(): signal sender is no button");
	std::exit(1);
    }
    
    QPushButton* senderButton =
	reinterpret_cast<QPushButton*>((QObject*)signalSender);
    
    int val = (senderButton->text()).toInt();
    //int d = _value.day();
    int m = _value.month();
    int y = _value.year();
    _value.setYMD(y,m,val);
    changed();
}


//::monthSlot()//::monthSlot()//::monthSlot()//::monthSlot()//::monthSlot()//::monthSlot()//::monthSlot()//::monthSlot()//::monthSlot()//::monthSlot()
void DateDialog::monthSlot() {
    const QObject* signalSender = sender();
    
    // This should never happen
    if( !(signalSender->isA("QPushButton")) ) {
	println()
	    ("FATAL: DateDialog::hourSlot(): signal sender is no button");
	std::exit(1);
    }
    
    QPushButton* senderButton =
	reinterpret_cast<QPushButton*>((QObject*)signalSender);
    
    const QString monthLabel = senderButton->text();
    const int val = monthNameToInt(monthLabel);
    const int d = _value.day();
    const int y = _value.year();
    _value.setYMD(y,val,d);
    changed();
}



//::yearSlot()//::yearSlot()//::yearSlot()//::yearSlot()//::yearSlot()//::yearSlot()//::yearSlot()//::yearSlot()//::yearSlot()//::yearSlot()//::yearSlot()
void DateDialog::yearSlot() {
    const int val = yearSpinBox->value();;
    const int d = _value.day();
    const int m = _value.month();
    _value.setYMD(val,m,d);
    changed();
}


//::changed()//::changed()//::changed()//::changed()//::changed()//::changed()//::changed()//::changed()//::changed()//::changed()//::changed()
void DateDialog::changed() {
    textLabel->setText( _value.toString() );
}


// I feel, that I could do better than that :-)
//::monthNameToInt()//::monthNameToInt()//::monthNameToInt()//::monthNameToInt()//::monthNameToInt()//::monthNameToInt()//::monthNameToInt()
int DateDialog::monthNameToInt(const QString& arg) const {
    if(arg == QString("Jan")) return 1;
    if(arg == QString("Feb")) return 2;
    if(arg == QString("Mar")) return 3;
    if(arg == QString("Apr")) return 4;
    if(arg == QString("May")) return 5;
    if(arg == QString("Jun")) return 6;
    if(arg == QString("Jul")) return 7;
    if(arg == QString("Aug")) return 8;
    if(arg == QString("Sep")) return 9;
    if(arg == QString("Oct")) return 10;
    if(arg == QString("Nov")) return 11;
    if(arg == QString("Dec")) return 12;
    
    return 0;
}



void DateDialog::reject() {
    _rejected = true;
    hide();
}





