// $Id: datedialog.h,v 1.3 2004/02/08 01:49:18 martin Exp $

// datedialog.h, (C) 2003 Martin Henne

/*
	Helper class for a gui to get a date specified by the user.
	See 'DateInput' for details and usage.
	
	Remark: This needs generated code from 'datedialogbase.ui'
*/

#ifndef _datedialog_h
#define _datedialog_h

#include "datedialogbase.h"
#include <qdatetime.h>

class QWidget;

class DateDialog : public DateDialogBase {
    private:
    QDate& _value;
    bool _rejected;
    
    public:
    DateDialog(
	QWidget* parent,
	const char* name,
	QDate& date);
    
    virtual void daySlot();
    virtual void monthSlot();
    virtual void yearSlot();
    virtual void accept();
    virtual void reject();
    
    bool rejected() const { return _rejected; }
    void changed();
    int monthNameToInt(const QString& monthName) const;
};


#endif
