//
// C++ Implementation: datepicker
//
// Description: 
//
//
// Author: Martin Henne <martin.henne@web.de>, (C) 2004
//
// Copyright: See COPYING file that comes with this distribution
//
//

#ifndef QWS
#error DatePicker needs the Qtopia API ('QWS' not defined)
#endif

#include "datepicker.h"
#include <qdatetime.h>
#include <qpoint.h>
#include <qwidget.h>
#include <qpopupmenu.h>
#include <qpe/datebookmonth.h>
#include <cstdio>

QDate DatePicker::show(const QPoint& pos) {
    DatePicker* dp = new DatePicker();
    QPopupMenu *popup = new QPopupMenu();
    DateBookMonth *dbm = new DateBookMonth( popup, 0, TRUE );
    popup->insertItem( dbm );
    popup->disconnect();
    dbm->disconnect();
    connect( dbm, SIGNAL( dateClicked( int, int, int ) ),
	     dp, SLOT( datePickedSlot( int, int, int ) ) );
    popup->exec(pos);
    std::fprintf(stderr,__FILE__ " show() leaving\n");
    return dp->_date;
}


QDate DatePicker::show(const QPoint& pos, const QDate& date) {
    DatePicker* dp = new DatePicker();
    QPopupMenu *popup = new QPopupMenu();
    DateBookMonth *dbm = new DateBookMonth( popup, 0, TRUE );
    popup->insertItem( dbm );
    popup->disconnect();
    dbm->disconnect();
    dbm->setDate(date);
    connect( dbm, SIGNAL( dateClicked( int, int, int ) ),
	     dp, SLOT( datePickedSlot( int, int, int ) ) );
    popup->exec(pos);
    std::fprintf(stderr,__FILE__ " show(..., ...) leaving\n");
    QDate toReturn = dp->_date;
    delete dp;
    dp = 0;
    return toReturn;
}


void DatePicker::datePickedSlot(int y, int m, int d) {
    std::fprintf(stderr,__FILE__ " datePickedSlot()\n");
    _date.setYMD(y,m,d);
}





