// $Id: datetimedialog.cpp,v 1.3 2004/01/03 22:51:34 martin Exp $

// datetimedialog.cpp, (C) 2003 Martin Henne

#include "datetimedialog.h"
#include "timeinput.h"
#include "dateinput.h"
#include <qwidget.h>
#include <qstring.h>
#include <qdatetime.h>
#include <qlabel.h>
#include "io.h"

DateTimeDialog::DateTimeDialog(
	QWidget* parent,
	const char* name,
	QDateTime& datetime
) : DateTimeDialogBase(parent,name,true,0), _value(datetime) {
	textLabel->setText( _value.toString() );
}

void DateTimeDialog::changed() {
	textLabel->setText( _value.toString() );
}

void DateTimeDialog::accept() {
	//println()(QString(__FILE__)+" accept()");
	hide();
}


void DateTimeDialog::setTimeSlot() {
	//println()(QString(__FILE__)+" setTimeSlot()");
	_value.setTime( TimeInput()() );
	changed();
}


void DateTimeDialog::setDateSlot() {
	//println()(QString(__FILE__)+" setDateSlot()");
	_value.setDate( DateInput()() );
	changed();
}

