// $Id: elementparser.cpp,v 1.8 2004/02/08 01:49:18 martin Exp $

// elementparser.cpp, (C) 2004 Martin Henne

#include "elementparser.h"
#include "activity.h"
#include "stringparser.h"
#include "io.h"
#include <qxml.h>
#include <qstring.h>
#include <qdatetime.h>
#include "mtrack.h"

ElementParser::ElementParser(QSortedList<Activity>& arg) :
	QXmlDefaultHandler(), _activityList(arg) {
}

bool ElementParser::startDocument() {
	//println()("ElementParser::startDocument() called");
	return true;
}


bool ElementParser::startElement(
	const QString& /*nameSpaceUri*/,
	const QString& /*localName*/,
	const QString& qName,
	const QXmlAttributes& attr
) {
	//println()("ElementParser::startElement() called");
	QString type = "(null)";
	type = qName;

	// parse finished activities
	if(type == QString("activity") ) {
		QString activityName = attr.value("name");
		QString activityStartString = attr.value("start");
		QDateTime activityStart =
			StringParser::getDateTime(activityStartString);
		QString activityEndString = attr.value("end");
		QDateTime activityEnd = StringParser::getDateTime(activityEndString);
		Activity* a = new Activity(activityName,activityStart);
		a->setEnd(activityEnd);
		_activityList.append(a);
	}

	// parse operative
	if(type == "operative") {
	    QString name = attr.value("name");
	    Mtrack::setOperative(name);
	}
	
	// parse unfinished (current) activity
	if(type == QString("unfinished") ) {
		QString activityStartString = attr.value("start");
		QDateTime activityStart =
			StringParser::getDateTime(activityStartString);
		Activity* a = new Activity(attr);
		a->setStart(activityStart);
		a->setEnd(QDateTime::currentDateTime());
		a->setCurrent(true);
		_activityList.append(a);
	}
	return true;
}


bool ElementParser::endElement(
	const QString& /*nameSpaceUri*/,
	const QString& /*localName*/,
	const QString& /*qName*/
) {
	//println()("ElementParser::endElement() called");
	return true;
}


