//
// C++ Implementation: quickdate
//
// Description: 
//
//
// Author: Martin Henne <martin.henne@web.de>, (C) 2004
//
// Copyright: See COPYING file that comes with this distribution
//
//

// TODO recognize the tap on days of the past or next month!
// TODO process day taps at all

/*
 *     TODO
 *
 *     Steal Code from ReportParams1.h/.cpp from TimeSleuth
 *     It uses <qpe/databookmonth> or something similiar 
 *     That looks fast and reliable.
 */


#include "quickdatebase.h"
#include "quickdate.h"
#include <qdatetime.h>
#include <qtable.h>
#include <cstdio>
#include <qcombobox.h>
#include <qheader.h>
#include <qspinbox.h>
#include <qpopupmenu.h>
#include <qpoint.h>

#ifdef QWS
#include <qpe/datebookmonth.h>
#endif

QuickDate::QuickDate(const QDate& current) : QuickDateBase(0,0,true,0) {
    _current = current;
    _rejected = false;
}


void QuickDate::backSlot() {
    // TODO finish this slot, when the fwdSlot() is finished
}


void QuickDate::fastBackSlot() {
    int currentItem = monthComboBox->currentItem();
    if(currentItem==0) {
	currentItem = 12;
	yearSpinBox->setValue(yearSpinBox->value()-1);
    }
    monthComboBox->setCurrentItem(--currentItem);
    QuickDate::fillTable(table, QDate(yearSpinBox->value(),currentItem+1,1) );
}


void QuickDate::fastFwdSlot() {
    int currentItem = monthComboBox->currentItem();
    if(currentItem==11) {
	currentItem = -1;
	yearSpinBox->setValue(yearSpinBox->value()+1);
    }
    monthComboBox->setCurrentItem(++currentItem);
    QuickDate::fillTable(table, QDate(yearSpinBox->value(),currentItem+1,1) );
}


void QuickDate::fwdSlot() { // TODO finish and fix this before copying it to the backSlot()
    int col = table->currentColumn();
    int row = table->currentRow();
    int month = monthComboBox->currentItem()+1;
    int year = yearSpinBox->value();
    if(col < 6) { // one right is possible
	++col;
    }
    else { // sunday
	col=0; // monday
	if(row==5) { // we need a new month
	    row=0; // set first week
	    if(month==12) { // we need a new year
		month=1; // january
		++year; // next year
	    }
	}
	else // not last row, so just go one row down
	    ++row;
    }
    table->setCurrentCell(row,col);
    QuickDate::fillTable(table, QDate(year,month,1) );
    return;    
}


void QuickDate::monthSlot() {
    int currentItem = monthComboBox->currentItem();
    QuickDate::fillTable(table, QDate(yearSpinBox->value(),currentItem+1,1) );    
}


void QuickDate::tableSlot() {
    std::fprintf(stderr,"QuickDate::tableSlot()\n");
}


void QuickDate::yearSlot() {
    int currentItem = monthComboBox->currentItem();
    QuickDate::fillTable(table, QDate(yearSpinBox->value(),currentItem+1,1) );        
}


void QuickDate::accept() {
    // TODO set correct date before hiding
    std::fprintf(stderr,"TODO\n");
    hide();
}


void QuickDate::reject() {
    // TODO mark rejected flag and reset date before hiding
    std::fprintf(stderr,"TODO\n");
    hide();
}


void QuickDate::fillTable(QTable* t, const QDate& today) {
    QDate d(today.year(),today.month(),1);
    d = d.addDays(-1 * (d.dayOfWeek()-1 ) );
    t->setNumRows(6);
    t->setNumCols(7);
    QHeader* hHeader = t->horizontalHeader();
    QHeader* vHeader = t->verticalHeader();
    hHeader->setResizeEnabled(false);
    vHeader->setResizeEnabled(false);
    QString s;
    hHeader->setLabel(0,"Mo");
    hHeader->setLabel(1,"Tu");
    hHeader->setLabel(2,"We");
    hHeader->setLabel(3,"Th");
    hHeader->setLabel(4,"Fr");
    hHeader->setLabel(5,"Sa");
    hHeader->setLabel(6,"Su");
    int week = 0 - d.day()/7; 
    int i=0;
    for(i=0; i<6; ++i) {
	s.sprintf("%d",week++); 
	vHeader->setLabel(i,s.latin1());
    }
    i=0;
    while(i<7) {
	t->setColumnWidth(i,23);
	++i;
    }
    i=0;
    while(i<6) {
	t->setRowHeight(i,18);
	++i;
    }
    t->setColumnMovingEnabled(false);
    t->setRowMovingEnabled(false);
    
    QString dayText;
    for(int i=0; i<6; ++i) {
	for(int ii=0; ii<7; ii++) {
	    dayText.sprintf("%d",d.day() ); 
	    t->setItem(i,ii,new QTableItem(t,QTableItem::Never,dayText.latin1()) );
	    if(d==today)
		t->setCurrentCell(i,ii);
	    d = d.addDays(1);
	}
    }    
}


QDate QuickDate::show(const QDate& cur, const QPoint& pos) {
    // TODO put the widget initialization in a seperate method initialize() or something similiar
    // TODO enshure that the correct date is returned, take care of reject()
#ifdef QWS
    return showQpe(cur, pos);
#endif
    
    QuickDate* d = new QuickDate(cur);
    d->monthComboBox->setCurrentItem(cur.month()-1);
    d->yearSpinBox->setValue(cur.year());
    QuickDate::fillTable( d->table, cur );
    d->exec();
    QDate rv = d->_date;
    delete d;
    d = 0;
    return rv;
}


#ifdef QWS
QDate QuickDate::showQpe(const QDate& cur, const QPoint& pos) {
    /*
    QuickDate* qd = new QuickDate();
    QPopupMenu *popup = new QPopupMenu();
    DateBookMonth *picker = new DateBookMonth( popup, 0, TRUE );
    popup->insertItem( picker );
    
    popup->popup(pos);	
    picker->setFocus();
    */
    return cur;
}
#endif




