//
// C++ Implementation: renamedialog
//
// Description: 
//
//
// Author: Martin Henne <martin.henne@web.de>, (C) 2004
//
// Copyright: See COPYING file that comes with this distribution
//
//

#include "renamedialog.h"
#include <qstring.h>
#include <qcombobox.h>
#include <qlineedit.h>
#include <qstringlist.h>

RenameDialog::RenameDialog(
    const QStringList& names, 
    QString& oldName, 
    QString& newName) 
    : 
    RenameDialogBase(0,0,true,0), 
    _oldName(oldName), 
    _newName(newName)
    {
    QStringList::ConstIterator iter = names.begin();
    while(iter != names.end() ) {
	projectsComboBox->insertItem(*iter);
	++iter;
    }
    newNameLineEdit->validateAndSet(_oldName,0,0,0);
}


void RenameDialog::accept() {
    int idx = projectsComboBox->currentItem();
    _oldName = projectsComboBox->text(idx);
    _newName = newNameLineEdit->text();
    hide();
}


void RenameDialog::reject() {
    hide();
}









