// $Id: reporter.h,v 1.6 2004/02/10 02:32:12 martin Exp $

// reporter.h, (C) 2004 Martin Henne

#ifndef _reporter_h
#define _reporter_h

#include <qsortedlist.h>
#include <qstring.h>
#include <qstringlist.h>
#include "activity.h"
class QDate;

class Reporter {
    private:
    
    static QString header(
	const QString& headLine);
    
    static QString footer(
	const QString& footNote = "");
    
    static QString tableData(
	const QString& content, 
	bool even=false);
    
    static QString tableRow(
	const QString& content, 
	bool even=false);
    
    static QString table(
	const QString& content);
    
    static QString createTableBlock(
	const QDate& firstDay,
	const QDate& lastDay,
	QSortedList<QString>& projectNames,
	QSortedList<Activity>& list);
    
    static QString toDateTimeString(const QDateTime& dt);
    static QString toDateString(const QDate& dt);
    
    
    public:    
    
    static QString createMonthly();
    
    static QString createWeekly();
    
    static QString createFull();
    
    static QString createDetails(
	const QSortedList<Activity>&,
	const QDate& firstDay,
	const QDate& lastDay);
    
    static QString createStandard(
	QSortedList<Activity>,
	QStringList projects,
	const QDate& firstDay,
	const QDate& lastDay,
	TimeSpan& carryOver,
	const float& dailyDebit,
	const int& annualLeave);
};

#endif


