// $Id: reportsettings.h,v 1.4 2004/02/09 00:53:45 martin Exp $

// reportsettings.h, (C) 2004 Martin Henne

#ifndef _reportsettings_h
#define _reportsettings_h

#include "reportsettingsbase.h"
#include "activityaccount.h"
#include <qdatetime.h>
#include <qstringlist.h>
#include <qsortedlist.h>

class TimeSpan;

class ReportSettings : public ReportSettingsBase {
    
    private:
    
    QSortedList<ActivityAccount>& _selectedProjects;
    QDate& _startDate;
    QDate& _endDate;
    TimeSpan& _carryOver;
    float& _dailyDebit;
    int& _annualLeave;
    bool& _accept;
    
    ReportSettings(
	QSortedList<ActivityAccount>& projects,
	QDate& start,
	QDate& end,
	TimeSpan& carryOver,
	float& dailyDebit,
	int& annualLeave,
	bool& accept);
    
    void initialize();
    
    void setDailyDebit(float val);
    
    virtual void endDateSlot();
    virtual void startDateSlot();
    virtual void projectSlot();
    virtual void quickReportSlot();
    virtual void selectAllSlot();
    virtual void selectNoneSlot();
    virtual void carryOverSlot();
    virtual void minusSlot();
    virtual void debitSlot();
    virtual void dailyDebitSlot();
    virtual void dailySlot();
    virtual void weeklySlot();
    virtual void monthlySlot();
    virtual void annualSlot();
    virtual void leaveSlot();
    virtual void reject();
    virtual void accept();
    virtual void helpReportSettingsSlot();
    void helpReportSettings();
    
    public:
    
    static void show (
	QSortedList<ActivityAccount>& projects,
	QDate& start,
	QDate& end,
	TimeSpan& carryOver,
	float& dailyDebit,
	int& annualLeave,
	bool& accept);

};

#endif



