// $Id: stringparser.cpp,v 1.3 2004/01/25 13:42:47 martin Exp $

// stringparser.cpp, (C) 2004 Martin Henne

#include "stringparser.h"
#include <qstring.h>
#include <qdatetime.h>


QDateTime StringParser::getDateTime(const QString& arg) {
	QString dateString = arg.left(10);
	QString timeString = arg.right(8);
	QDate date = getDate(dateString);
	QTime time = getTime(timeString);
	return QDateTime(date,time);
}


QDate StringParser::getDate(const QString& arg) {
	QString dayString = arg.mid(3,2);
	QString monthString = arg.left(2);
	QString yearString = arg.right(4);
	bool success = true;
	int day = dayString.toInt(&success,10);
	int month = monthString.toInt(&success,10);
	int year = yearString.toInt(&success,10);
	return QDate(year,month,day);
}


QTime StringParser::getTime(const QString& arg) {
	QString hourString = arg.left(2);
	QString minString = arg.mid(3,2);
	QString secString = arg.right(2);
	bool success = true;
	int hour = hourString.toInt(&success,10);
	int min = minString.toInt(&success,10);
	int sec = secString.toInt(&success,10);
	return QTime(hour,min,sec);
}


QString StringParser::toString(const QDateTime& dt) {
	QString dateString = StringParser::toString(dt.date());
	QString timeString = StringParser::toString(dt.time());
	QString s(dateString + " " + timeString);
	return s;
}


QString StringParser::toString(const QDate& date) {
	QString s;
	s.sprintf("%.2d/%.2d/%.2d",date.month(),date.day(),date.year()%10000);
	return s;
}


QString StringParser::toString(const QTime& time) {
	return time.toString();
}




