// $Id: timedialog.cpp,v 1.2 2004/01/04 14:34:42 martin Exp $

// timedialog.cpp, (C) 2003 Martin Henne

#include "timedialog.h"
#include <qwidget.h>
#include <qstring.h>
#include <qdatetime.h>
#include <qlabel.h>
#include <qpushbutton.h>
#include <cstdlib>
#include "io.h"


TimeDialog::TimeDialog(
	QWidget* parent,
	const char* name,
	QTime& time
) : TimeDialogBase(parent,name,true,0), _value(time) {
	int currentHour = _value.hour();
	int currentMinute = _value.minute();
	_value.setHMS(currentHour,currentMinute,0,0);
	changed();
}



void TimeDialog::changed() {
	textLabel->setText( _value.toString() );
}



void TimeDialog::accept() {
	//println()(__FILE__);
	hide();
}



void TimeDialog::hourSlot() {
	const QObject* signalSender = sender();

	// This should never happen
	if( !(signalSender->isA("QPushButton")) ) {
		println()
			("FATAL: TimeDialog::hourSlot(): signal sender is no button");
		std::exit(1);
	}

	QPushButton* senderButton =
		reinterpret_cast<QPushButton*>((QObject*)signalSender);

	int buttonVal = (senderButton->text()).toInt();
	int currentMinuteVal = _value.minute();
	_value.setHMS(buttonVal,currentMinuteVal,0,0);
	changed();
}



void TimeDialog::minuteSlot() {
	const QObject* signalSender = sender();

	// This should never happen
	if( !(signalSender->isA("QPushButton")) ) {
		println()
			("FATAL: TimeDialog::minuteSlot(): signal sender is no button");
		std::exit(1);
	}

	QPushButton* senderButton =
		reinterpret_cast<QPushButton*>((QObject*)signalSender);

	int buttonVal = (senderButton->text()).toInt();
	int currentHourVal = _value.hour();
	_value.setHMS(currentHourVal,buttonVal,0,0);
	changed();
}
