// $Id: timediff.h,v 1.2 2004/01/05 16:02:49 martin Exp $

// timediff.h, (C) 2003 M. Henne

/*
	Get the difference between to times in minutes. Example:

	QTime t1(17,0,0);  // 17:00 h
	QTime t2(18,10,0); // 18:10 h
	int diff = TimeDiff::minutes(t1,t2);

	// diff holds now '70'
	// Instead of QTime, you can also use QDateTime, if
	// you have terms that span over one ore more days.
*/

#ifndef _timediff_h
#define _timediff_h

#include <qdatetime.h>

class TimeDiff {
public:
	static int minutes(
		const QTime& start,
		const QTime& end
	);

	static int minutes(
		const QDateTime& start,
		const QDateTime& end
	);

};


#endif
