// $Id: timespan.cpp,v 1.6 2004/02/10 02:32:12 martin Exp $

// timespan.cpp, (C) 2004 Martin Henne

#include "timespan.h"

TimeSpan::TimeSpan(float decHours) {
    _hours = (int) decHours;
    float decMinutes = (decHours-_hours)*60.0;
    _minutes = (int) decMinutes;
    float decSeconds = (decMinutes-_minutes)*60.0;
    _seconds = (int) decSeconds;
    //std::fprintf(stderr,"TimeSpan(%f): %s\n",decHours,this->toString().latin1() );
}

TimeSpan TimeSpan::operator+(const TimeSpan& other) const {
    TimeSpan span;
    int thisSeconds = this->_hours*60*60+this->_minutes*60+this->_seconds;
    int otherSeconds = other._hours*60*60+other._minutes*60+other._seconds;
    thisSeconds += otherSeconds;
    span._hours = thisSeconds/(60*60);
    thisSeconds -= span._hours*60*60;
    span._minutes = thisSeconds/60;
    thisSeconds -= span._minutes*60;
    span._seconds = thisSeconds;
    return span;
}

void TimeSpan::operator+=(const TimeSpan& other) {
    TimeSpan span = *this + other;
    *this = span;
}


bool TimeSpan::operator==(const TimeSpan& other) const {
    if(
	other._hours == this->_hours &&
		      other._minutes == this->_minutes &&
				      other._seconds == this->_seconds
						      )
	return true;
    return false;
}


bool TimeSpan::operator<(const TimeSpan& other) const {
    if(this->_hours < other._hours) return true;
    if(this->_hours > other._hours) return false;
    if(this->_hours == other._hours) {
	if(this->_minutes < other._minutes) return true;
	if(this->_minutes > other._minutes) return false;
	if(this->_minutes == other._minutes) {
	    if(this->_seconds < other._seconds) return true;
	    if(this->_seconds > other._seconds) return false;
	}
    }
    return false;
}


bool TimeSpan::zero() const {
    return ( minutes()==0 && seconds()==0 && hours()==0 );
}






