// $Id: timespan.h,v 1.5 2004/02/08 19:19:25 martin Exp $

// timespan.h, (C) 2004 Martin Henne

#ifndef _timespan_h
#define _timespan_h

#include <cstdio>
#include <cstdlib>
#include <qstring.h>

class TimeSpan {
    private:
    int _hours;
    int _minutes;
    int _seconds;
    public:
    TimeSpan() : _hours(0), _minutes(0), _seconds(0) {}
    TimeSpan(int h, int m, int s) : _hours(h), _minutes(m), _seconds(s) {}
    TimeSpan(float decHours);
    TimeSpan(int secs) {
	this->_hours = secs/(60*60);
	secs -= this->_hours*60*60;
	this->_minutes = secs/60;
	secs -= this->_minutes*60;
	this->_seconds = secs;
    }
    QString toString() const {
	QString s;
	int min = _minutes;
	if(min<0)
	    min *= -1;
	int sec = _seconds;
	if(sec<0)
	    sec *= -1;
	s.sprintf("%.2i:%.2i:%.2i",_hours,min,sec);
	return s;
    }
    QString toShortString() const {
	QString s;
	int min = _minutes;
	if(min<0)
	    min *= -1;
	s.sprintf("%.2i:%.2i",_hours,min);
	return s;
    }
    void hours(int h) {
	_hours = h;
    }
    int hours() const {
	return _hours;
    }
    void minutes(int m) {
	_minutes = m;
    }
    int minutes() const {
	return _minutes;
    }
    void seconds(int s) {
	_seconds = s;
    }
    int seconds() const {
	return _seconds;
    }
    
    TimeSpan operator+(const TimeSpan& other) const;
    void operator+=(const TimeSpan& other);
    bool operator==(const TimeSpan& other) const;
    bool operator<(const TimeSpan& other) const;
    
    bool zero() const;
};

#endif
