// $Id: window.h,v 1.29 2004/02/11 02:42:18 martin Exp $

// windowslots.h, (C) 2003 Martin Henne

/*
	This is the main window of 'mTrack'. All GUI
	stuff starts here!
*/

#include "windowbase.h"
#include "activityaccount.h"
#include <qinputdialog.h>
#include <qdatetime.h>
#include <qstring.h>
#include <qsortedlist.h>

#ifndef _windowslots_h
#define _windowslots_h

class QWidget;
class WFlags;
class Mtrack;
class TimeSpan;
class QTimer;


class Window : public WindowBase {
    private:
    QString& _userInput; // is this really needed?
    Mtrack* _mtrack; // connection to the main application
    QTimer* _timer; // for autosave and gui updates
    int _updates; // count update events
    bool _modifyListCreated;
    
    TimeSpan _carryOver;
    float _dailyDebit;
    int _annualLeave;
    
    public:
    Window(
	Mtrack* mtrack,
	QString& ui,
	QWidget* parent = 0,
	const char* name = 0,
	WFlags flags = 0);
    
    ~Window();
    virtual void comboBoxSlot();
    virtual void clearAllSlot();
    virtual void newActivitySlot();
    virtual void tapOnListSlot();
    virtual void updateTimesSlot();
    virtual void removeActivitySlot();
    virtual void resetActivitySlot();
    virtual void resetAllSlot();
    virtual void tapOnModifyListSlot();
    virtual void generateActivityListSlot(const QString& project);
    virtual void projectHelpSlot();
    virtual void modifyHelpSlot();
    virtual void lastMonthSlot();
    virtual void reportComboBoxSlot();
    virtual void createAndModifyActivitySlot();
    virtual void tabChangedSlot();
    virtual void helpReportSlot();
    virtual void modifyComboBoxSlot();
    void createAndModifyActivity();
    void reportDetails();
    void reportFull();
    void reportStandard(
	QSortedList<ActivityAccount> projects,
	const QDate& start, 
	const QDate& end,
	TimeSpan& carryOver,
	const float& dailyDebit,
	const int& annualLeave);
    void showActivityAccount(const QString& name, const TimeSpan& time);
    void showAccounts();
    void setSelected(const QString& activityAccountName);
    void setTimesLine(const QString& line);
    void updateTimesLine();
    void update();
    void initialize();
    void setVersion(const QString& version);
    void saveReport();
    void helpReport();
    void test();
};

#endif




